<template>
  <table class="m-character-stats__table">
    <thead>
      <tr>
        <th colspan="2" class="m-character-stats__head">
          <h4 v-if="isEditable" class="m-character-stats__available">
            Доступно {{ availablePoint }} очков
          </h4>
        </th>
      </tr>
    </thead>

    <tbody>
      <tr>
        <td class="m-character-stats__label">
          Сила
        </td>
        <td class="m-character-stats__value">
          <m-stats-counter
            v-model="propStats.strength"
            :current="immutableStats.strength"
            :available="availablePoint"
            :editable="isEditable"
            @change="updateAvailablePoints"
          />
        </td>
      </tr>

      <tr>
        <td class="m-character-stats__label">
          Выносливость
        </td>
        <td class="m-character-stats__value">
          <m-stats-counter
            v-model="propStats.vitality"
            :current="immutableStats.vitality"
            :available="availablePoint"
            :editable="isEditable"
            @change="updateAvailablePoints"
          />
        </td>
      </tr>

      <tr>
        <td class="m-character-stats__label">
          Ловкость
        </td>
        <td class="m-character-stats__value">
          <m-stats-counter
            v-model="propStats.dexterity"
            :current="immutableStats.dexterity"
            :available="availablePoint"
            :editable="isEditable"
            @change="updateAvailablePoints"
          />
        </td>
      </tr>

      <tr>
        <td class="m-character-stats__label">
          Интеллект
        </td>
        <td class="m-character-stats__value">
          <m-stats-counter
            v-model="propStats.intelligence"
            :current="immutableStats.intelligence"
            :available="availablePoint"
            :editable="isEditable"
            @change="updateAvailablePoints"
          />
        </td>
      </tr>
    </tbody>

    <tfoot>
      <tr>
        <td colspan="2">
          <div class="m-character-stats__footer">
            <template v-if="isOwnerProfile">
              <el-button type="info" @click="$emit('reset')">
                сбросить
              </el-button>
              <el-button
                v-if="isEditable"
                type="success"
                class="murr-button__success"
                @click="$emit('save')"
              >
                сохранить
              </el-button>
            </template>
          </div>
        </td>
      </tr>
    </tfoot>
  </table>
</template>

<script>
import MStatsCounter from "./MStatsCounter.vue";

export default {
  name: "MCharacterStatsTableStats",
  components: {
    MStatsCounter,
  },
  props: {
    stats: {
      type: Object,
      required: true,
    },
    immutableStats: {
      type: Object,
      required: true,
    },
  },
  data() {
    return {
      propStats: this.stats,
    };
  },
  computed: {
    isOwnerProfile() {
      return (
        this.$store.getters.currentMurren.id ===
        this.$store.getters.profileData.id
      );
    },
    availablePoint() {
      return this.stats.available_points;
    },
    isEditable() {
      return this.isOwnerProfile && this.immutableStats.available_points > 0;
    },
    isExistsAvailablePoints() {
      return this.availablePoint > 0;
    },
  },
  methods: {
    updateAvailablePoints(points) {
      this.$emit("caculate", points);
    },
  },
  watch: {
    stats() {
      this.propStats = this.stats;
    },
  },
};
</script>
